const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inspecao_aereaDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inspecao_aerea = await db.inspecao_aerea.create(
      {
        id: data.id || undefined,

        data_inspecao: data.data_inspecao || null,
        tipo_inspecao: data.tipo_inspecao || null,
        observacoes: data.observacoes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await inspecao_aerea.setObra(data.obra || null, {
      transaction,
    });

    await inspecao_aerea.setClientes(data.clientes || null, {
      transaction,
    });

    return inspecao_aerea;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const inspecao_aereaData = data.map((item, index) => ({
      id: item.id || undefined,

      data_inspecao: item.data_inspecao || null,
      tipo_inspecao: item.tipo_inspecao || null,
      observacoes: item.observacoes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const inspecao_aerea = await db.inspecao_aerea.bulkCreate(
      inspecao_aereaData,
      { transaction },
    );

    // For each item created, replace relation files

    return inspecao_aerea;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const inspecao_aerea = await db.inspecao_aerea.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.data_inspecao !== undefined)
      updatePayload.data_inspecao = data.data_inspecao;

    if (data.tipo_inspecao !== undefined)
      updatePayload.tipo_inspecao = data.tipo_inspecao;

    if (data.observacoes !== undefined)
      updatePayload.observacoes = data.observacoes;

    updatePayload.updatedById = currentUser.id;

    await inspecao_aerea.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await inspecao_aerea.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await inspecao_aerea.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return inspecao_aerea;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inspecao_aerea = await db.inspecao_aerea.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of inspecao_aerea) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of inspecao_aerea) {
        await record.destroy({ transaction });
      }
    });

    return inspecao_aerea;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inspecao_aerea = await db.inspecao_aerea.findByPk(id, options);

    await inspecao_aerea.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await inspecao_aerea.destroy({
      transaction,
    });

    return inspecao_aerea;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const inspecao_aerea = await db.inspecao_aerea.findOne(
      { where },
      { transaction },
    );

    if (!inspecao_aerea) {
      return inspecao_aerea;
    }

    const output = inspecao_aerea.get({ plain: true });

    output.frames_imagem_inspecao =
      await inspecao_aerea.getFrames_imagem_inspecao({
        transaction,
      });

    output.gemeos_digitais_inspecao =
      await inspecao_aerea.getGemeos_digitais_inspecao({
        transaction,
      });

    output.relatorios_analiticos_video_inspecao =
      await inspecao_aerea.getRelatorios_analiticos_video_inspecao({
        transaction,
      });

    output.obra = await inspecao_aerea.getObra({
      transaction,
    });

    output.clientes = await inspecao_aerea.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.tipo_inspecao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'inspecao_aerea',
            'tipo_inspecao',
            filter.tipo_inspecao,
          ),
        };
      }

      if (filter.observacoes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'inspecao_aerea',
            'observacoes',
            filter.observacoes,
          ),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              data_inspecao: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              data_inspecao: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.data_inspecaoRange) {
        const [start, end] = filter.data_inspecaoRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_inspecao: {
              ...where.data_inspecao,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_inspecao: {
              ...where.data_inspecao,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.inspecao_aerea.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('inspecao_aerea', 'tipo_inspecao', query),
        ],
      };
    }

    const records = await db.inspecao_aerea.findAll({
      attributes: ['id', 'tipo_inspecao'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['tipo_inspecao', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.tipo_inspecao,
    }));
  }
};
